]> arthur.barton.de Git - bup.git/blobdiff - cmd/web-cmd.py
Fix release archives and add tests
[bup.git] / cmd / web-cmd.py
index e32fbb8a75f975102635554f58aee4c885a0438b..4add17c1ca20237d10854ce0482ce7ff5d39aa39 100755 (executable)
-#!/usr/bin/env python
-import sys, stat, cgi, shutil, urllib, mimetypes, posixpath, time
-import tornado.httpserver
-import tornado.ioloop
-import tornado.web
+#!/bin/sh
+"""": # -*-python-*-
+bup_python="$(dirname "$0")/bup-python" || exit $?
+exec "$bup_python" "$0" ${1+"$@"}
+"""
+# end of bup preamble
+
+from collections import namedtuple
+import mimetypes, os, posixpath, signal, stat, sys, time, urllib, webbrowser
+
 from bup import options, git, vfs
-from bup.helpers import *
+from bup.helpers import (chunkyreader, debug1, handle_ctrl_c, log,
+                         resource_path, saved_errors)
+
+try:
+    from tornado import gen
+    from tornado.httpserver import HTTPServer
+    from tornado.ioloop import IOLoop
+    from tornado.netutil import bind_unix_socket
+    import tornado.web
+except ImportError:
+    log('error: cannot find the python "tornado" module; please install it\n')
+    sys.exit(1)
+
 
 handle_ctrl_c()
 
+
+def _compute_breadcrumbs(path, show_hidden=False):
+    """Returns a list of breadcrumb objects for a path."""
+    breadcrumbs = []
+    breadcrumbs.append(('[root]', '/'))
+    path_parts = path.split('/')[1:-1]
+    full_path = '/'
+    for part in path_parts:
+        full_path += part + "/"
+        url_append = ""
+        if show_hidden:
+            url_append = '?hidden=1'
+        breadcrumbs.append((part, full_path+url_append))
+    return breadcrumbs
+
+
+def _contains_hidden_files(n):
+    """Return True if n contains files starting with a '.', False otherwise."""
+    for sub in n:
+        name = sub.name
+        if len(name)>1 and name.startswith('.'):
+            return True
+
+    return False
+
+
+def _compute_dir_contents(n, path, show_hidden=False):
+    """Given a vfs node, returns an iterator for display info of all subs."""
+    url_append = ""
+    if show_hidden:
+        url_append = "?hidden=1"
+
+    if path != "/":
+        yield('..', '../' + url_append, '')
+    for sub in n:
+        display = sub.name
+        link = urllib.quote(sub.name)
+
+        # link should be based on fully resolved type to avoid extra
+        # HTTP redirect.
+        if stat.S_ISDIR(sub.try_resolve().mode):
+            link += "/"
+
+        if not show_hidden and len(display)>1 and display.startswith('.'):
+            continue
+
+        size = None
+        if stat.S_ISDIR(sub.mode):
+            display += '/'
+        elif stat.S_ISLNK(sub.mode):
+            display += '@'
+        else:
+            size = sub.size()
+            size = (opt.human_readable and format_filesize(size)) or size
+
+        yield (display, link + url_append, size)
+
+
 class BupRequestHandler(tornado.web.RequestHandler):
+
+    def decode_argument(self, value, name=None):
+        if name == 'path':
+            return value
+        return super(BupRequestHandler, self).decode_argument(value, name)
+
     def get(self, path):
         return self._process_request(path)
 
     def head(self, path):
         return self._process_request(path)
-
+    
     def _process_request(self, path):
         path = urllib.unquote(path)
         print 'Handling request for %s' % path
@@ -39,62 +120,20 @@ class BupRequestHandler(tornado.web.RequestHandler):
             print 'Redirecting from %s to %s' % (path, path + '/')
             return self.redirect(path + '/', permanent=True)
 
-        self.set_header("Content-Type", "text/html")
-
-        displaypath = cgi.escape(path)
-        self.write("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
-<html>
-  <head>
-    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
-    <title>Directory listing for %(displaypath)s</title>
-    <style type="text/css">
-      body, table { font-family: sans-serif }
-      #breadcrumb { margin: 10px 0; }
-      .dir-name { text-align: left }
-      .dir-size { text-align: right }
-    </style>
-  </head>
-  <body>
-    <div id="breadcrumb">
-""" % { 'displaypath': displaypath })
-        if path == "/":
-            self.write("""<strong>[root]</strong>""")
-        else:
-            self.write("""<a href="/">[root]</a> """)
-            path_parts = path.split("/")
-            path_parts_cleaned = path_parts[1:-1]
-            for index, value in enumerate(path_parts_cleaned[0:-1]):
-                self.write("""/ <a href="/%(path)s/">%(element)s</a> """ % { 'path' : "/".join(path_parts_cleaned[0:(index + 1)]) , 'element' : value})
-            self.write("""/ <strong>%s</strong>""" % path_parts_cleaned[-1])
-        self.write("""
-    </div>
-    <table>
-      <tr>
-        <th class="dir-name">Name</th>
-        <th class="dir-size">Size</th>
-      </tr>
-""")
-        for sub in n:
-            displayname = linkname = sub.name
-            # Append / for directories or @ for symbolic links
-            size = str(sub.size())
-            if stat.S_ISDIR(sub.mode):
-                displayname = sub.name + "/"
-                linkname = sub.name + "/"
-                size = '&nbsp;'
-            if stat.S_ISLNK(sub.mode):
-                displayname = sub.name + "@"
-                # Note: a link to a directory displays with @ and links with /
-                size = '&nbsp;'
-            self.write("""      <tr>
-        <td class="dir-name"><a href="%s">%s</a></td>
-        <td class="dir-size">%s</td>
-      </tr>""" % (urllib.quote(linkname), cgi.escape(displayname), size))
-        self.write("""
-    </table>
-  </body>
-</html>""")
+        try:
+            show_hidden = int(self.request.arguments.get('hidden', [0])[-1])
+        except ValueError as e:
+            show_hidden = False
+
+        self.render(
+            'list-directory.html',
+            path=path,
+            breadcrumbs=_compute_breadcrumbs(path, show_hidden),
+            files_hidden=_contains_hidden_files(n),
+            hidden_shown=show_hidden,
+            dir_contents=_compute_dir_contents(n, path, show_hidden))
 
+    @gen.coroutine
     def _get_file(self, path, n):
         """Process a request on a file.
 
@@ -102,17 +141,21 @@ class BupRequestHandler(tornado.web.RequestHandler):
         In either case, the headers are sent.
         """
         ctype = self._guess_type(path)
-
         self.set_header("Last-Modified", self.date_time_string(n.mtime))
         self.set_header("Content-Type", ctype)
         size = n.size()
         self.set_header("Content-Length", str(size))
-
+        assert(len(n.hash) == 20)
+        self.set_header("Etag", n.hash.encode('hex'))
         if self.request.method != 'HEAD':
             f = n.open()
-            for blob in chunkyreader(f):
-                self.write(blob)
-            f.close()
+            try:
+                it = chunkyreader(f)
+                for blob in chunkyreader(f):
+                    self.write(blob)
+            finally:
+                f.close()
+        raise gen.Return()
 
     def _guess_type(self, path):
         """Guess the type of a file.
@@ -150,43 +193,94 @@ class BupRequestHandler(tornado.web.RequestHandler):
         return time.strftime('%a, %d %b %Y %H:%M:%S', time.gmtime(t))
 
 
+io_loop = None
+
+def handle_sigterm(signum, frame):
+    global io_loop
+    debug1('\nbup-web: signal %d received\n' % signum)
+    log('Shutdown requested\n')
+    if not io_loop:
+        sys.exit(0)
+    io_loop.stop()
+
+
+signal.signal(signal.SIGTERM, handle_sigterm)
+
+UnixAddress = namedtuple('UnixAddress', ['path'])
+InetAddress = namedtuple('InetAddress', ['host', 'port'])
+
 optspec = """
 bup web [[hostname]:port]
+bup web unix://path
 --
+human-readable    display human readable file sizes (i.e. 3.9K, 4.7M)
+browser           show repository in default browser (incompatible with unix://)
 """
-o = options.Options('bup web', optspec)
+o = options.Options(optspec)
 (opt, flags, extra) = o.parse(sys.argv[1:])
 
 if len(extra) > 1:
     o.fatal("at most one argument expected")
 
-address = ('127.0.0.1', 8080)
-if len(extra) > 0:
-    addressl = extra[0].split(':', 1)
-    addressl[1] = int(addressl[1])
-    address = tuple(addressl)
+if len(extra) == 0:
+    address = InetAddress(host='127.0.0.1', port=8080)
+else:
+    bind_url = extra[0]
+    if bind_url.startswith('unix://'):
+        address = UnixAddress(path=bind_url[len('unix://'):])
+    else:
+        addr_parts = extra[0].split(':', 1)
+        if len(addr_parts) == 1:
+            host = '127.0.0.1'
+            port = addr_parts[0]
+        else:
+            host, port = addr_parts
+        try:
+            port = int(port)
+        except (TypeError, ValueError) as ex:
+            o.fatal('port must be an integer, not %r', port)
+        address = InetAddress(host=host, port=port)
 
 git.check_repo_or_die()
 top = vfs.RefList(None)
 
-(pwd,junk) = os.path.split(sys.argv[0])
-
 settings = dict(
     debug = 1,
+    template_path = resource_path('web'),
+    static_path = resource_path('web/static')
 )
 
 # Disable buffering on stdout, for debug messages
 sys.stdout = os.fdopen(sys.stdout.fileno(), 'w', 0)
 
 application = tornado.web.Application([
-    (r"(/.*)", BupRequestHandler),
+    (r"(?P<path>/.*)", BupRequestHandler),
 ], **settings)
 
-if __name__ == "__main__":
-    http_server = tornado.httpserver.HTTPServer(application)
-    http_server.listen(address[1], address=address[0])
+http_server = HTTPServer(application)
+io_loop_pending = IOLoop.instance()
+
+if isinstance(address, InetAddress):
+    http_server.listen(address.port, address.host)
+    try:
+        sock = http_server._socket # tornado < 2.0
+    except AttributeError as e:
+        sock = http_server._sockets.values()[0]
+    print "Serving HTTP on %s:%d..." % sock.getsockname()
+    if opt.browser:
+        browser_addr = 'http://' + address[0] + ':' + str(address[1])
+        io_loop_pending.add_callback(lambda : webbrowser.open(browser_addr))
+elif isinstance(address, UnixAddress):
+    unix_socket = bind_unix_socket(address.path)
+    http_server.add_socket(unix_socket)
+    print "Serving HTTP on filesystem socket %r" % address.path
+else:
+    log('error: unexpected address %r', address)
+    sys.exit(1)
 
-    print "Serving HTTP on %s:%d..." % http_server._socket.getsockname()
-    loop = tornado.ioloop.IOLoop.instance()
-    loop.start()
+io_loop = io_loop_pending
+io_loop.start()
 
+if saved_errors:
+    log('WARNING: %d errors encountered while saving.\n' % len(saved_errors))
+    sys.exit(1)